## zydis 3.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1 FATAL_ERROR)
include(GenerateExportHeader)
include(GNUInstallDirs)

project(Zydis VERSION 3.1.0.0 LANGUAGES C CXX)

# =============================================================================================== #
# Overridable options                                                                             #
# =============================================================================================== #

# Features
option(ZYDIS_MINIMAL_MODE
    "Enable minimal mode (forces ZYDIS_DECODER_MODE_MINIMAL runtime option)"
    OFF)
option(ZYDIS_FEATURE_DECODER
    "Enable instruction decoding functionality"
    ON)
option(ZYDIS_FEATURE_FORMATTER
    "Enable instruction formatting functionality"
    ON)
option(ZYDIS_FEATURE_AVX512
    "Enable support for AVX-512 instructions"
    ON)
option(ZYDIS_FEATURE_KNC
    "Enable support for KNC instructions"
    ON)

# Build configuration
option(ZYDIS_BUILD_SHARED_LIB
    "Build shared library"
    OFF)
option(ZYDIS_BUILD_EXAMPLES
    "Build examples"
    ON)
option(ZYDIS_BUILD_TOOLS
    "Build tools"
    ON)
option(ZYDIS_FUZZ_AFL_FAST
    "Enables AFL persistent mode and reduces prints in ZydisFuzzIn"
    OFF)
option(ZYDIS_LIBFUZZER
    "Enables LLVM libfuzzer mode and reduces prints in ZydisFuzzIn"
    OFF)
set(ZYDIS_ZYCORE_PATH
    "${CMAKE_CURRENT_LIST_DIR}/dependencies/zycore"
    CACHE
    PATH
    "The path to look for Zycore")

# =============================================================================================== #
# Dependencies                                                                                    #
# =============================================================================================== #

if (NOT EXISTS "${ZYDIS_ZYCORE_PATH}/CMakeLists.txt")
    message(
        FATAL_ERROR
        "Can't find zycore submodule. Please make sure to clone the repo recursively.\n"
        "You can fix this by running\n"
        "    git submodule update --init\n"
        "or by cloning using\n"
        "    git clone --recursive <url>\n"
        "Alternatively, you can manually clone zycore to some path and set ZYDIS_ZYCORE_PATH."
    )
endif ()

add_subdirectory(${ZYDIS_ZYCORE_PATH} "zycore" EXCLUDE_FROM_ALL)

# =============================================================================================== #
# Library configuration                                                                           #
# =============================================================================================== #

if (ZYDIS_BUILD_SHARED_LIB)
    add_library("Zydis" SHARED)
else ()
    add_library("Zydis" STATIC)
endif ()

target_link_libraries("Zydis" PUBLIC "Zycore")
target_include_directories("Zydis"
    PUBLIC "include" ${PROJECT_BINARY_DIR}
    PRIVATE "src")
target_compile_definitions("Zydis" PRIVATE "_CRT_SECURE_NO_WARNINGS" "ZYDIS_EXPORTS")
zyan_set_common_flags("Zydis")
zyan_maybe_enable_wpo_for_lib("Zydis")
generate_export_header("Zydis" BASE_NAME "ZYDIS" EXPORT_FILE_NAME "ZydisExportConfig.h")

if (ZYDIS_FEATURE_FORMATTER AND NOT ZYDIS_FEATURE_DECODER)
    message(
        FATAL_ERROR
        "\nZYDIS_FEATURE_FORMATTER requires ZYDIS_FEATURE_DECODER to be enabled"
    )
endif ()

if (ZYDIS_MINIMAL_MODE)
    target_compile_definitions("Zydis" PUBLIC "ZYDIS_MINIMAL_MODE")
endif ()
if (NOT ZYDIS_FEATURE_DECODER)
    target_compile_definitions("Zydis" PUBLIC "ZYDIS_DISABLE_DECODER")
endif ()
if (NOT ZYDIS_FEATURE_FORMATTER)
    target_compile_definitions("Zydis" PUBLIC "ZYDIS_DISABLE_FORMATTER")
endif ()
if (NOT ZYDIS_FEATURE_AVX512)
    target_compile_definitions("Zydis" PUBLIC "ZYDIS_DISABLE_AVX512")
endif ()
if (NOT ZYDIS_FEATURE_KNC)
    target_compile_definitions("Zydis" PUBLIC "ZYDIS_DISABLE_KNC")
endif ()

target_sources("Zydis"
    PRIVATE
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/MetaInfo.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Mnemonic.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Register.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/SharedTypes.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/ShortString.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Status.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Utils.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Zydis.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Internal/SharedData.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Internal/String.h"
        "src/MetaInfo.c"
        "src/Mnemonic.c"
        "src/Register.c"
        "src/SharedData.c"
        "src/String.c"
        "src/Utils.c"
        "src/Zydis.c")

if (ZYDIS_FEATURE_DECODER)
    target_sources("Zydis"
        PRIVATE
            "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Decoder.h"
            "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/DecoderTypes.h"
            "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Internal/DecoderData.h"
            "src/Decoder.c"
            "src/DecoderData.c")
    if (ZYDIS_FEATURE_FORMATTER AND (NOT ZYDIS_MINIMAL_MODE))
        target_sources("Zydis"
            PRIVATE
                "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Formatter.h"
                "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/FormatterBuffer.h"
                "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Internal/FormatterATT.h"
                "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Internal/FormatterBase.h"
                "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Internal/FormatterIntel.h"
                "src/Formatter.c"
                "src/FormatterBuffer.c"
                "src/FormatterATT.c"
                "src/FormatterBase.c"
                "src/FormatterIntel.c")
    endif ()
endif ()

if (ZYDIS_BUILD_SHARED_LIB AND WIN32)
    target_sources("Zydis" PRIVATE "resources/VersionInfo.rc")
endif ()

zyan_set_source_group("Zydis")

# TODO: Install CMake config.
install(TARGETS "Zydis"
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES
    "${PROJECT_BINARY_DIR}/ZydisExportConfig.h"
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
install(DIRECTORY "include/" DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

function (_maybe_set_emscripten_cfg target)
    if (EMSCRIPTEN)
        # Yep, that madness below is how Emscripten likes its quotes.
        set_target_properties("${target}"
            PROPERTIES COMPILE_FLAGS
            "-s \"EXPORT_NAME='${target}'\" -s MODULARIZE=1")
        set_target_properties("${target}"
            PROPERTIES LINK_FLAGS_RELEASE
            "-s \"EXPORT_NAME='${target}'\" -s MODULARIZE=1")
    endif ()
endfunction ()

# =============================================================================================== #
# Examples                                                                                        #
# =============================================================================================== #

if (ZYDIS_BUILD_EXAMPLES AND NOT ZYAN_NO_LIBC)
    if (ZYDIS_FEATURE_DECODER AND ZYDIS_FEATURE_FORMATTER AND (NOT ZYDIS_MINIMAL_MODE))
        add_executable("Formatter01" "examples/Formatter01.c")
        target_link_libraries("Formatter01" "Zydis")
        set_target_properties("Formatter01" PROPERTIES FOLDER "Examples/Formatter")
        target_compile_definitions("Formatter01" PRIVATE "_CRT_SECURE_NO_WARNINGS")
        zyan_set_common_flags("Formatter01")
        zyan_maybe_enable_wpo("Formatter01")
        _maybe_set_emscripten_cfg("Formatter01")

        add_executable("Formatter02" "examples/Formatter02.c")
        target_link_libraries("Formatter02" "Zydis")
        set_target_properties("Formatter02" PROPERTIES FOLDER "Examples/Formatter")
        target_compile_definitions("Formatter02" PRIVATE "_CRT_SECURE_NO_WARNINGS")
        zyan_set_common_flags("Formatter02")
        zyan_maybe_enable_wpo("Formatter02")
        _maybe_set_emscripten_cfg("Formatter02")

        add_executable("Formatter03" "examples/Formatter03.c")
        target_link_libraries("Formatter03" "Zydis")
        set_target_properties("Formatter03" PROPERTIES FOLDER "Examples/Formatter")
        target_compile_definitions("Formatter03" PRIVATE "_CRT_SECURE_NO_WARNINGS")
        zyan_set_common_flags("Formatter03")
        zyan_maybe_enable_wpo("Formatter03")
        _maybe_set_emscripten_cfg("Formatter03")

        add_executable("ZydisPerfTest" "examples/ZydisPerfTest.c")
        target_link_libraries("ZydisPerfTest" "Zydis")
        set_target_properties("ZydisPerfTest" PROPERTIES FOLDER "Examples")
        target_compile_definitions("ZydisPerfTest" PRIVATE "_CRT_SECURE_NO_WARNINGS")
        zyan_set_common_flags("ZydisPerfTest")
        zyan_maybe_enable_wpo("ZydisPerfTest")
        _maybe_set_emscripten_cfg("ZydisPerfTest")
        if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux"
                OR ${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
            target_compile_definitions("ZydisPerfTest" PRIVATE "_GNU_SOURCE")
            find_package(Threads REQUIRED)
            target_link_libraries("ZydisPerfTest" Threads::Threads)
        endif ()
    endif ()
endif ()

# =============================================================================================== #
# Tools                                                                                           #
# =============================================================================================== #

if (ZYDIS_BUILD_TOOLS AND NOT ZYAN_NO_LIBC)
    if (ZYDIS_FEATURE_DECODER AND ZYDIS_FEATURE_FORMATTER AND (NOT ZYDIS_MINIMAL_MODE))
        add_executable("ZydisDisasm" "tools/ZydisDisasm.c")
        target_link_libraries("ZydisDisasm" "Zydis")
        set_target_properties ("ZydisDisasm" PROPERTIES FOLDER "Tools")
        target_compile_definitions("ZydisDisasm" PRIVATE "_CRT_SECURE_NO_WARNINGS")
        zyan_set_common_flags("ZydisDisasm")
        zyan_maybe_enable_wpo("ZydisDisasm")
        _maybe_set_emscripten_cfg("ZydisDisasm")
        install(TARGETS "ZydisDisasm" RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

        add_executable("ZydisFuzzIn" "tools/ZydisFuzzIn.c")
        target_link_libraries("ZydisFuzzIn" "Zydis")
        set_target_properties("ZydisFuzzIn" PROPERTIES FOLDER "Tools")
        target_compile_definitions("ZydisFuzzIn" PRIVATE "_CRT_SECURE_NO_WARNINGS")
        zyan_set_common_flags("ZydisFuzzIn")
        zyan_maybe_enable_wpo("ZydisFuzzIn")
        _maybe_set_emscripten_cfg("ZydisFuzzIn")
        if (ZYDIS_FUZZ_AFL_FAST)
            target_compile_definitions("ZydisFuzzIn" PRIVATE "ZYDIS_FUZZ_AFL_FAST")
        endif ()
        if (ZYDIS_LIBFUZZER)
            target_compile_definitions("ZydisFuzzIn" PRIVATE "ZYDIS_LIBFUZZER")
        endif ()

        add_executable("ZydisInfo" "tools/ZydisInfo.c")
        target_link_libraries("ZydisInfo" "Zydis")
        set_target_properties ("ZydisInfo" PROPERTIES FOLDER "Tools")
        target_compile_definitions("ZydisInfo" PRIVATE "_CRT_SECURE_NO_WARNINGS")
        zyan_set_common_flags("ZydisInfo")
        zyan_maybe_enable_wpo("ZydisInfo")
        _maybe_set_emscripten_cfg("ZydisInfo")
        install(TARGETS "ZydisInfo" RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

        #add_executable("ZydisPE" "tools/ZydisPE.c")
        #target_link_libraries("ZydisPE" "Zydis")
        #set_target_properties ("ZydisPE" PROPERTIES FOLDER "Tools")
        #target_compile_definitions("ZydisPE" PRIVATE "_CRT_SECURE_NO_WARNINGS")
        #zyan_set_common_flags("ZydisPE")
        #zyan_maybe_enable_wpo("ZydisPE")
        #_maybe_set_emscripten_cfg("ZydisPE")
    endif ()
endif ()

=== debian/changelog ===
zydis (3.1.0-1) unstable; urgency=low

  * Initial release. Closes: #995921

 -- Andrea Pappacoda <andrea@pappacoda.it>  Fri, 08 Oct 2021 12:42:28 +0200

=== debian/control ===
Source: zydis
Section: libs
Priority: optional
Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
Build-Depends: debhelper-compat (= 13), cmake, libzycore-dev
Standards-Version: 4.6.0
Homepage: https://zydis.re
Rules-Requires-Root: no

Package: libzydis3.1
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: fast and lightweight x86/x86-64 disassembler library
 Zydis is a fast x86/x86-64 disassembler library. It supports all x86 and
 AMD64 instructions and extensions, doesn't perform dynamic memory
 allocations, is thread safe by design and has no third party dependency -
 not even libc.
 .
 This package contains the shared library.

Package: libzydis-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libzydis3.1 (= ${binary:Version}),
Description: fast and lightweight x86/x86-64 disassembler library - development
 Zydis is a fast x86/x86-64 disassembler library. It supports all x86 and
 AMD64 instructions and extensions, doesn't perform dynamic memory
 allocations, is thread safe by design and has no third party dependency -
 not even libc.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_TARGET_MULTIARCH)" \
		-DZYDIS_BUILD_SHARED_LIB=ON \
		-DZYDIS_BUILD_EXAMPLES=OFF \
		-DZYDIS_BUILD_TOOLS=OFF \
		-DZYDIS_SYSTEM_ZYCORE=ON

## zydis 3.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,10 @@
 cmake_minimum_required(VERSION 3.1 FATAL_ERROR)
+
+project(Zydis VERSION 3.2.1.0 LANGUAGES C CXX)
+
 include(GenerateExportHeader)
 include(GNUInstallDirs)
-
-project(Zydis VERSION 3.1.0.0 LANGUAGES C CXX)
+include(CMakePackageConfigHelpers)
 
 # =============================================================================================== #
 # Overridable options                                                                             #
@@ -50,6 +52,18 @@
 # =============================================================================================== #
 # Dependencies                                                                                    #
 # =============================================================================================== #
+
+# Try to initialize the Zycore submodule using Git
+if (NOT EXISTS "${ZYDIS_ZYCORE_PATH}/CMakeLists.txt" AND 
+    "${ZYDIS_ZYCORE_PATH}" STREQUAL "${CMAKE_CURRENT_LIST_DIR}/dependencies/zycore")
+    find_package(Git QUIET)
+    if(GIT_FOUND AND EXISTS "${PROJECT_SOURCE_DIR}/.git")
+        execute_process(
+            COMMAND ${GIT_EXECUTABLE} submodule update --init --recursive 
+            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} 
+        )
+    endif()
+endif ()
 
 if (NOT EXISTS "${ZYDIS_ZYCORE_PATH}/CMakeLists.txt")
     message(
@@ -77,9 +91,15 @@
 
 target_link_libraries("Zydis" PUBLIC "Zycore")
 target_include_directories("Zydis"
-    PUBLIC "include" ${PROJECT_BINARY_DIR}
+    PUBLIC
+        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
+        $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
+        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
     PRIVATE "src")
 target_compile_definitions("Zydis" PRIVATE "_CRT_SECURE_NO_WARNINGS" "ZYDIS_EXPORTS")
+set_target_properties("Zydis" PROPERTIES
+    VERSION ${Zydis_VERSION}
+    SOVERSION ${Zydis_VERSION_MAJOR}.${Zydis_VERSION_MINOR})
 zyan_set_common_flags("Zydis")
 zyan_maybe_enable_wpo_for_lib("Zydis")
 generate_export_header("Zydis" BASE_NAME "ZYDIS" EXPORT_FILE_NAME "ZydisExportConfig.h")
@@ -157,11 +177,28 @@
 
 zyan_set_source_group("Zydis")
 
-# TODO: Install CMake config.
+configure_package_config_file(cmake/zydis-config.cmake.in
+    "${CMAKE_CURRENT_BINARY_DIR}/zydis-config.cmake"
+    INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/zydis"
+)
+write_basic_package_version_file(
+    "${CMAKE_CURRENT_BINARY_DIR}/zydis-config-version.cmake"
+    COMPATIBILITY SameMajorVersion
+)
+install(FILES
+    "${CMAKE_CURRENT_BINARY_DIR}/zydis-config.cmake"
+    "${CMAKE_CURRENT_BINARY_DIR}/zydis-config-version.cmake"
+    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/zydis"
+)
+
 install(TARGETS "Zydis"
+    EXPORT "zydis-targets"
     ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
     LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
     RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+install(EXPORT "zydis-targets"
+    NAMESPACE "Zydis::"
+    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/zydis")
 install(FILES
     "${PROJECT_BINARY_DIR}/ZydisExportConfig.h"
     DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
@@ -251,24 +288,3 @@
             target_compile_definitions("ZydisFuzzIn" PRIVATE "ZYDIS_FUZZ_AFL_FAST")
         endif ()
         if (ZYDIS_LIBFUZZER)
-            target_compile_definitions("ZydisFuzzIn" PRIVATE "ZYDIS_LIBFUZZER")
-        endif ()
-
-        add_executable("ZydisInfo" "tools/ZydisInfo.c")
-        target_link_libraries("ZydisInfo" "Zydis")
-        set_target_properties ("ZydisInfo" PROPERTIES FOLDER "Tools")
-        target_compile_definitions("ZydisInfo" PRIVATE "_CRT_SECURE_NO_WARNINGS")
-        zyan_set_common_flags("ZydisInfo")
-        zyan_maybe_enable_wpo("ZydisInfo")
-        _maybe_set_emscripten_cfg("ZydisInfo")
-        install(TARGETS "ZydisInfo" RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
-
-        #add_executable("ZydisPE" "tools/ZydisPE.c")
-        #target_link_libraries("ZydisPE" "Zydis")
-        #set_target_properties ("ZydisPE" PROPERTIES FOLDER "Tools")
-        #target_compile_definitions("ZydisPE" PRIVATE "_CRT_SECURE_NO_WARNINGS")
-        #zyan_set_common_flags("ZydisPE")
-        #zyan_maybe_enable_wpo("ZydisPE")
-        #_maybe_set_emscripten_cfg("ZydisPE")
-    endif ()
-endif ()

=== debian/changelog ===
zydis (3.2.1-5) unstable; urgency=medium

  * d/libzydis3.2.symbols: explicitly exclude x32 from 32-bits symbols
  * d/rules: enable BUILD_RPATH_USE_ORIGIN
  * d/watch: use GitHub's API

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 13 Jan 2022 10:57:32 +0100

zydis (3.2.1-4) unstable; urgency=medium

  * d/control: depend on zycore >= 1.1.0-3 for testing migration
  * d/control: add Vcs fields
  * d/rules: drop superfluous -DCMAKE_LIBRARY_ARCHITECTURE

 -- Andrea Pappacoda <andrea@pappacoda.it>  Mon, 06 Dec 2021 21:59:47 +0100

zydis (3.2.1-3) unstable; urgency=medium

  * libzydis-dev: add Depends on libzycore-dev
  * d/rules: enable qa features in DEB_BUILD_MAINT_OPTIONS
  * Switch to git-buildpackage based packaging

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 21 Nov 2021 01:47:02 +0100

zydis (3.2.1-2) unstable; urgency=medium

  * Source-only reupload

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 16 Nov 2021 09:13:55 +0100

zydis (3.2.1-1) unstable; urgency=medium

  * New upstream release.
    - CVE-2021-41253 (Closes: #999431)
    - New package libzydis3.2, dropped libzydis3.1
  * d/control: reword description. Closes: #996390
  * Add zydis-tools package
  * d/rules: run tests
  * d/control: mark packages with Multi-Arch

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 11 Nov 2021 12:21:08 +0100

=== debian/control ===
Source: zydis
Section: libs
Priority: optional
Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libzycore-dev (>= 1.1.0-3),
               python3 <!nocheck>,
               ronn
Standards-Version: 4.6.0
Homepage: https://zydis.re
Vcs-Git: https://salsa.debian.org/debian/zydis.git
Vcs-Browser: https://salsa.debian.org/debian/zydis
Rules-Requires-Root: no

Package: libzydis3.2
Architecture: any-amd64 any-arm any-arm64 any-i386
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: fast and lightweight x86/x86-64 disassembler library
 Zydis is a fast x86/x86-64 disassembler library. It supports all x86 and
 AMD64 instructions and many vendor extensions, doesn't perform dynamic
 memory allocations, is thread safe by design and has no third party
 dependency - not even libc.
 .
 This package contains the shared library.

Package: libzydis-dev
Section: libdevel
Architecture: any-amd64 any-arm any-arm64 any-i386
Multi-Arch: same
Depends: libzycore-dev (>= 1.0.0-2),
         libzydis3.2 (= ${binary:Version}),
         ${misc:Depends}
Description: fast and lightweight x86/x86-64 disassembler library - development
 Zydis is a fast x86/x86-64 disassembler library. It supports all x86 and
 AMD64 instructions and many vendor extensions, doesn't perform dynamic
 memory allocations, is thread safe by design and has no third party
 dependency - not even libc.
 .
 This package contains the development files.

Package: zydis-tools
Section: devel
Architecture: any-amd64 any-arm any-arm64 any-i386
Multi-Arch: foreign
Depends: libzydis3.2 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: fast and lightweight x86/x86-64 disassembler library - tools
 Zydis is a fast x86/x86-64 disassembler library. It supports all x86 and
 AMD64 instructions and many vendor extensions, doesn't perform dynamic
 memory allocations, is thread safe by design and has no third party
 dependency - not even libc.
 .
 This package contains the command line tools.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all qa=+all

%:
	dh $@ --builddir=build

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_SHARED_LIBS=ON \
		-DZYDIS_BUILD_SHARED_LIB=ON \
		-DZYDIS_BUILD_EXAMPLES=OFF \
		-DZYDIS_BUILD_TOOLS=ON \
		-DZYDIS_SYSTEM_ZYCORE=ON \
		-DZYDIS_BUILD_MAN=ON \
		-DCMAKE_BUILD_RPATH_USE_ORIGIN=ON

override_dh_auto_test:
	cd tests && python3 regression.py test ../build/ZydisInfo

=== debian/watch ===
version=4
opts="searchmode=plain, \
  filenamemangle=s/.+\/v@ANY_VERSION@/@PACKAGE@-$1\.tar\.gz/, \
  pgpmode=none" \
https://api.github.com/repos/zyantific/zydis/tags \
https://api.github.com/repos/zyantific/zydis/tarball/refs/tags/v@ANY_VERSION@

## zydis 4.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9 FATAL_ERROR)

if (CMAKE_VERSION VERSION_GREATER_EQUAL "3.15")
    # Enable runtime library selection via CMAKE_MSVC_RUNTIME_LIBRARY
    cmake_policy(SET CMP0091 NEW)
endif ()

project(Zydis VERSION 4.0.0.0 LANGUAGES C CXX)

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

# =============================================================================================== #
# Overridable options                                                                             #
# =============================================================================================== #

# Features
option(ZYDIS_MINIMAL_MODE
    "Enable minimal mode (forces ZYDIS_DECODER_MODE_MINIMAL runtime option)"
    OFF)
option(ZYDIS_FEATURE_DECODER
    "Enable instruction decoding functionality"
    ON)
option(ZYDIS_FEATURE_ENCODER
    "Enable instruction encoding functionality"
    ON)
option(ZYDIS_FEATURE_FORMATTER
    "Enable instruction formatting functionality"
    ON)
option(ZYDIS_FEATURE_AVX512
    "Enable support for AVX-512 instructions"
    ON)
option(ZYDIS_FEATURE_KNC
    "Enable support for KNC instructions"
    ON)
option(ZYDIS_FEATURE_SEGMENT
    "Enable instruction segment API"
    ON)

# Build configuration
option(ZYDIS_BUILD_SHARED_LIB
    "Build shared library"
    OFF)
option(ZYDIS_BUILD_EXAMPLES
    "Build examples"
    ON)
option(ZYDIS_BUILD_TOOLS
    "Build tools"
    ON)
option(ZYDIS_BUILD_MAN
    "Build manpages for the tools (requires Ronn-NG)"
    OFF)
option(ZYDIS_BUILD_DOXYGEN
    "Build doxygen documentation (requires Doxygen)"
    ON)
option(ZYDIS_FUZZ_AFL_FAST
    "Enables AFL persistent mode and reduces prints in ZydisFuzzIn"
    OFF)
option(ZYDIS_LIBFUZZER
    "Enables LLVM libfuzzer mode and reduces prints in ZydisFuzzIn"
    OFF)

# Dependencies
option(ZYAN_SYSTEM_ZYCORE
    "Use system Zycore library"
    OFF)
set(ZYAN_ZYCORE_PATH
    "${CMAKE_CURRENT_LIST_DIR}/dependencies/zycore"
    CACHE
    PATH
    "The path to look for Zycore")

# =============================================================================================== #
# Dependencies                                                                                    #
# =============================================================================================== #

if (ZYAN_SYSTEM_ZYCORE)
    find_package(Zycore)
else ()
    # Try to initialize the Zycore submodule using Git
    if (NOT EXISTS "${ZYAN_ZYCORE_PATH}/CMakeLists.txt" AND 
        "${ZYAN_ZYCORE_PATH}" STREQUAL "${CMAKE_CURRENT_LIST_DIR}/dependencies/zycore")
        find_package(Git QUIET)
        if(GIT_FOUND AND EXISTS "${PROJECT_SOURCE_DIR}/.git")
            execute_process(
                COMMAND ${GIT_EXECUTABLE} submodule update --init --recursive 
                WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} 
            )
        endif()
    endif ()

    if (NOT EXISTS "${ZYAN_ZYCORE_PATH}/CMakeLists.txt")
        message(
            FATAL_ERROR
            "Can't find zycore submodule. Please make sure to clone the repo recursively.\n"
            "You can fix this by running\n"
            "    git submodule update --init\n"
            "or by cloning using\n"
            "    git clone --recursive <url>\n"
            "Alternatively, you can manually clone zycore to some path and set ZYDIS_ZYCORE_PATH."
        )
    endif ()

    add_subdirectory(${ZYAN_ZYCORE_PATH} "zycore" EXCLUDE_FROM_ALL)
endif ()

# =============================================================================================== #
# Library configuration                                                                           #
# =============================================================================================== #

if (ZYDIS_BUILD_SHARED_LIB)
    add_library("Zydis" SHARED)
else ()
    add_library("Zydis" STATIC)
    target_compile_definitions("Zydis" PUBLIC "ZYDIS_STATIC_BUILD")
endif ()

target_link_libraries("Zydis" PUBLIC "Zycore")
target_include_directories("Zydis"
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
    PRIVATE "src")
target_compile_definitions("Zydis" PRIVATE "_CRT_SECURE_NO_WARNINGS")
set_target_properties("Zydis" PROPERTIES
    VERSION "${Zydis_VERSION}"
    SOVERSION "${Zydis_VERSION_MAJOR}.${Zydis_VERSION_MINOR}"
    DEFINE_SYMBOL "ZYDIS_SHOULD_EXPORT")
zyan_set_common_flags("Zydis")
zyan_maybe_enable_wpo("Zydis")

if (ZYDIS_FEATURE_FORMATTER AND NOT ZYDIS_FEATURE_DECODER)
    message(
        FATAL_ERROR
        "\nZYDIS_FEATURE_FORMATTER requires ZYDIS_FEATURE_DECODER to be enabled"
    )
endif ()

if (ZYDIS_FEATURE_ENCODER AND (ZYDIS_MINIMAL_MODE OR
                               NOT ZYDIS_FEATURE_DECODER OR
                               NOT ZYDIS_FEATURE_AVX512 OR
                               NOT ZYDIS_FEATURE_KNC))
    message(
        FATAL_ERROR
        "\nZYDIS_FEATURE_ENCODER requires ZYDIS_FEATURE_DECODER in full mode (ZYDIS_MINIMAL_MODE \
        disabled) with all ISA extensions (ZYDIS_FEATURE_AVX512 and ZYDIS_FEATURE_KNC enabled)"
    )
endif ()

if (ZYDIS_MINIMAL_MODE)
    target_compile_definitions("Zydis" PUBLIC "ZYDIS_MINIMAL_MODE")
endif ()
if (NOT ZYDIS_FEATURE_DECODER)
    target_compile_definitions("Zydis" PUBLIC "ZYDIS_DISABLE_DECODER")
endif ()
if (NOT ZYDIS_FEATURE_ENCODER)
    target_compile_definitions("Zydis" PUBLIC "ZYDIS_DISABLE_ENCODER")
endif ()
if (NOT ZYDIS_FEATURE_FORMATTER)
    target_compile_definitions("Zydis" PUBLIC "ZYDIS_DISABLE_FORMATTER")
endif ()
if (NOT ZYDIS_FEATURE_AVX512)
    target_compile_definitions("Zydis" PUBLIC "ZYDIS_DISABLE_AVX512")
endif ()
if (NOT ZYDIS_FEATURE_KNC)
    target_compile_definitions("Zydis" PUBLIC "ZYDIS_DISABLE_KNC")
endif ()
if (NOT ZYDIS_FEATURE_SEGMENT)
    target_compile_definitions("Zydis" PUBLIC "ZYDIS_DISABLE_SEGMENT")
endif ()

target_sources("Zydis"
    PRIVATE
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Defines.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/MetaInfo.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Mnemonic.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Register.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Segment.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/SharedTypes.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/ShortString.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Status.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Utils.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Zydis.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Internal/SharedData.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Internal/String.h"
        "src/MetaInfo.c"
        "src/Mnemonic.c"
        "src/Register.c"
        "src/Segment.c"
        "src/SharedData.c"
        "src/String.c"
        "src/Utils.c"
        "src/Zydis.c")

if (ZYDIS_FEATURE_DECODER)
    target_sources("Zydis"
        PRIVATE
            "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Decoder.h"
            "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/DecoderTypes.h"
            "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Internal/DecoderData.h"
            "src/Decoder.c"
            "src/DecoderData.c")
    if (ZYDIS_FEATURE_ENCODER)
        target_sources("Zydis"
            PRIVATE
                "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Encoder.h"
                "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Internal/EncoderData.h"
                "src/Encoder.c"
                "src/EncoderData.c")
    endif ()
    if (ZYDIS_FEATURE_FORMATTER AND (NOT ZYDIS_MINIMAL_MODE))
        target_sources("Zydis"
            PRIVATE
                "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Disassembler.h"
                "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Formatter.h"
                "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/FormatterBuffer.h"
                "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Internal/FormatterATT.h"
                "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Internal/FormatterBase.h"
                "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Internal/FormatterIntel.h"
                "src/Disassembler.c"
                "src/Formatter.c"
                "src/FormatterBuffer.c"
                "src/FormatterATT.c"
                "src/FormatterBase.c"
                "src/FormatterIntel.c")
    endif ()
    if (ZYDIS_FEATURE_SEGMENT)
        target_sources("Zydis"
            PRIVATE
                "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Segment.h"
                "src/Segment.c")
    endif ()
endif ()

if (ZYDIS_BUILD_SHARED_LIB AND WIN32)
    target_sources("Zydis" PRIVATE "resources/VersionInfo.rc")
endif ()

zyan_set_source_group("Zydis")

configure_package_config_file(cmake/zydis-config.cmake.in
    "${CMAKE_CURRENT_BINARY_DIR}/zydis-config.cmake"
    INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/zydis"
)
write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/zydis-config-version.cmake"
    COMPATIBILITY SameMajorVersion
)
install(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/zydis-config.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/zydis-config-version.cmake"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/zydis"
)

install(TARGETS "Zydis"
    EXPORT "zydis-targets"
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(EXPORT "zydis-targets"
    NAMESPACE "Zydis::"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/zydis")
install(DIRECTORY "include/" DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

function (_maybe_set_emscripten_cfg target)
    if (EMSCRIPTEN)
        # Yep, that madness below is how Emscripten likes its quotes.
        set_target_properties("${target}"
            PROPERTIES COMPILE_FLAGS
            "-s \"EXPORT_NAME='${target}'\" -s MODULARIZE=1")
        set_target_properties("${target}"
            PROPERTIES LINK_FLAGS_RELEASE
            "-s \"EXPORT_NAME='${target}'\" -s MODULARIZE=1")
    endif ()
endfunction ()

function(_add_example target source_file sub_folder)
    add_executable("${target}" "examples/${source_file}")
    target_link_libraries("${target}" "Zydis")
    set_target_properties("${target}" PROPERTIES FOLDER "Examples/${sub_folder}")
    target_compile_definitions("${target}" PRIVATE "_CRT_SECURE_NO_WARNINGS")
    zyan_set_common_flags("${target}")
    zyan_maybe_enable_wpo("${target}")
    _maybe_set_emscripten_cfg("${target}")
endfunction()

# =============================================================================================== #
# Examples                                                                                        #
# =============================================================================================== #

if (ZYDIS_BUILD_EXAMPLES AND NOT ZYAN_NO_LIBC)
    if (ZYDIS_FEATURE_DECODER AND ZYDIS_FEATURE_FORMATTER AND (NOT ZYDIS_MINIMAL_MODE))
        _add_example("DisassembleSimple" "DisassembleSimple.c" "Decoder")
        _add_example("Disassemble" "Disassemble.c" "Decoder")
        _add_example("Formatter01" "Formatter01.c" "Decoder")
        _add_example("Formatter02" "Formatter02.c" "Decoder")
        _add_example("Formatter03" "Formatter03.c" "Decoder")
        _add_example("ZydisPerfTest" "ZydisPerfTest.c" "Decoder")
        if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux"
                OR ${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
            target_compile_definitions("ZydisPerfTest" PRIVATE "_GNU_SOURCE")
            find_package(Threads REQUIRED)
            target_link_libraries("ZydisPerfTest" Threads::Threads)
        endif ()
    endif ()

    if (ZYDIS_FEATURE_ENCODER)
        _add_example("EncodeMov" "EncodeMov.c" "Encoder")
        _add_example("EncodeFromScratch" "EncodeFromScratch.c" "Encoder")
        _add_example("RewriteCode" "RewriteCode.c" "Encoder")
    endif ()
endif ()

=== Makefile ===
.PHONY: build configure install amalgamate clean test doc doc-plain doc-themed

BUILD_DIR ?= build
CSS_DIR   ?= ../doxygen-awesome-css

build: configure
	cmake --build $(BUILD_DIR) -j$(nproc)

configure: dependencies/zycore/CMakeLists.txt
	@if ! command -v cmake > /dev/null; then \
		echo >&2 "ERROR: cmake is not installed. Please install it first."; \
	fi
	cmake -B $(BUILD_DIR)

install: build
	cmake --install $(BUILD_DIR)

amalgamate:
	assets/amalgamate.py

clean:
	rm -rf $(BUILD_DIR)
	rm -rf doc
	rm -rf amalgamated-dist

test: build
	cd tests && ./regression.py test ../build/ZydisInfo
	cd tests && ./regression_encoder.py ../build/Zydis{Fuzz{ReEncoding,Encoder},TestEncoderAbsolute}

doc: configure
	cmake --build $(BUILD_DIR) --target ZydisDoc

dependencies/zycore/CMakeLists.txt:
	@if ! command -v git > /dev/null; then \
		echo >&2 -n "ERROR: git is not installed. Please either manually place all"; \
		echo >&2    "dependencies in their respective paths or install git first."; \
		exit 1; \
	fi
	git submodule update --init --recursive

=== debian/changelog ===
zydis (4.0.0-2.1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:56:35 +1100

zydis (4.0.0-2.1build1) noble; urgency=medium

  * No-change rebuild against libzycore1.4t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 19 Mar 2024 05:58:01 +0000

zydis (4.0.0-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063315

 -- Steve Langasek <vorlon@debian.org>  Thu, 29 Feb 2024 08:51:11 +0000

zydis (4.0.0-2) unstable; urgency=medium

  * d/patches: add loong64 support.
    Thanks to wuruilong for the patch! (Closes: #1055146)

 -- Andrea Pappacoda <andrea@pappacoda.it>  Fri, 12 Jan 2024 23:36:45 +0100

zydis (4.0.0-1) unstable; urgency=medium

  * New upstream version 4.0.0
  * Upload to unstable

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 24 Nov 2022 10:56:33 +0100

zydis (4.0.0~rc.1-1) experimental; urgency=medium

  * New upstream version 4.0.0~rc.1
  * d/control: libzydis3.2 -> libzydis4.0
  * d/control: add new libzydis-doc package
  * d/control: build on any architecture
  * d/patches: drop upstreamed patches

 -- Andrea Pappacoda <andrea@pappacoda.it>  Mon, 07 Nov 2022 01:39:25 +0100

zydis (3.2.1-6) unstable; urgency=medium

  * d/patches: build Doxygen documentation
  * d/rules: enable BUILD_RPATH_USE_ORIGIN
  * d/tests: add autopkgtests

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 02 Oct 2022 15:14:14 +0200

=== debian/control ===
--- 
+++ 
@@ -1,20 +1,31 @@
 Source: zydis
 Section: libs
 Priority: optional
-Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
-Build-Depends: cmake,
-               debhelper-compat (= 13),
-               libzycore-dev (>= 1.1.0-3),
-               python3 <!nocheck>,
-               ronn
-Standards-Version: 4.6.0
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13)
+Build-Depends-Arch: dpkg-dev (>= 1.22.5), cmake,
+                    libzycore-dev (>= 1.1.0-3),
+                    python3 <!nocheck>,
+                    ronn
+Build-Depends-Indep: cmake,
+                     doxygen <!nodoc>,
+                     doxygen-awesome-css <!nodoc>,
+                     graphviz <!nodoc>,
+                     libzycore-dev (>= 1.1.0-3),
+                     python3 <!nocheck>,
+                     ronn
+Standards-Version: 4.6.2
 Homepage: https://zydis.re
 Vcs-Git: https://salsa.debian.org/debian/zydis.git
 Vcs-Browser: https://salsa.debian.org/debian/zydis
 Rules-Requires-Root: no
 
-Package: libzydis3.2
-Architecture: any-amd64 any-arm any-arm64 any-i386
+Package: libzydis4.0t64
+Provides: ${t64:Provides}
+Replaces: libzydis4.0
+Breaks: libzydis4.0 (<< ${source:Version})
+Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends},
          ${shlibs:Depends}
@@ -28,10 +39,10 @@
 
 Package: libzydis-dev
 Section: libdevel
-Architecture: any-amd64 any-arm any-arm64 any-i386
+Architecture: any
 Multi-Arch: same
 Depends: libzycore-dev (>= 1.0.0-2),
-         libzydis3.2 (= ${binary:Version}),
+         libzydis4.0t64 (= ${binary:Version}),
          ${misc:Depends}
 Description: fast and lightweight x86/x86-64 disassembler library - development
  Zydis is a fast x86/x86-64 disassembler library. It supports all x86 and
@@ -41,11 +52,24 @@
  .
  This package contains the development files.
 
+Package: libzydis-doc
+Section: doc
+Architecture: all
+Multi-Arch: foreign
+Depends: ${misc:Depends}
+Description: fast and lightweight x86/x86-64 disassembler library - documentation
+ Zydis is a fast x86/x86-64 disassembler library. It supports all x86 and
+ AMD64 instructions and many vendor extensions, doesn't perform dynamic
+ memory allocations, is thread safe by design and has no third party
+ dependency - not even libc.
+ .
+ This package contains the generated Doxygen documentation.
+
 Package: zydis-tools
 Section: devel
-Architecture: any-amd64 any-arm any-arm64 any-i386
+Architecture: any
 Multi-Arch: foreign
-Depends: libzydis3.2 (= ${binary:Version}),
+Depends: libzydis4.0t64 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
 Description: fast and lightweight x86/x86-64 disassembler library - tools

=== debian/rules ===
#!/usr/bin/make -f

# optimize=-lto because I use CMake's LTO
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto qa=+all

%:
	dh $@ --builddir=build

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_INTERPROCEDURAL_OPTIMIZATION=ON \
		-DCMAKE_POLICY_DEFAULT_CMP0069=NEW \
		-DBUILD_SHARED_LIBS=ON \
		-DZYDIS_BUILD_SHARED_LIB=ON \
		-DZYDIS_BUILD_EXAMPLES=OFF \
		-DZYDIS_BUILD_TOOLS=ON \
		-DZYAN_SYSTEM_ZYCORE=ON \
		-DZYDIS_BUILD_MAN=ON \
		-DCMAKE_BUILD_RPATH_USE_ORIGIN=ON

override_dh_auto_test:
	cd tests && python3 regression.py test ../build/ZydisInfo

override_dh_installdocs-indep:
	dh_installdocs --indep --doc-main-package=libzydis-doc

override_dh_installexamples-indep:
	dh_installexamples --indep --doc-main-package=libzydis-doc

ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
execute_after_dh_installdocs-indep:
	dh_doxygen --indep
endif

=== debian/tests/control ===
Tests: cmake
Depends: @, cmake, gcc | c-compiler, libc-dev

=== debian/watch ===
version=4
opts="searchmode=plain, \
  filenamemangle=s/.+\/v@ANY_VERSION@/@PACKAGE@-$1\.tar\.gz/, \
  uversionmangle=s/-rc/~rc/, \
  pgpmode=none" \
https://api.github.com/repos/zyantific/zydis/tags \
https://api.github.com/repos/zyantific/zydis/tarball/refs/tags/v@ANY_VERSION@

## zydis 4.1.0

=== Makefile ===
--- 
+++ 
@@ -10,7 +10,7 @@
 	@if ! command -v cmake > /dev/null; then \
 		echo >&2 "ERROR: cmake is not installed. Please install it first."; \
 	fi
-	cmake -B $(BUILD_DIR)
+	cmake -B $(BUILD_DIR) -DZYDIS_BUILD_TESTS=ON
 
 install: build
 	cmake --install $(BUILD_DIR)
@@ -24,8 +24,7 @@
 	rm -rf amalgamated-dist
 
 test: build
-	cd tests && ./regression.py test ../build/ZydisInfo
-	cd tests && ./regression_encoder.py ../build/Zydis{Fuzz{ReEncoding,Encoder},TestEncoderAbsolute}
+	cd $(BUILD_DIR) && ctest
 
 doc: configure
 	cmake --build $(BUILD_DIR) --target ZydisDoc

=== debian/changelog ===
zydis (4.1.0-3) unstable; urgency=low

  * Upload to unstable
  * First dgit upload

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 14 Jan 2025 22:24:32 +0100

zydis (4.1.0-2) experimental; urgency=medium

  * d/.symbols: drop ZydisStringAppend*U32 symbols

 -- Andrea Pappacoda <andrea@pappacoda.it>  Wed, 10 Apr 2024 07:36:44 +0200

zydis (4.1.0-1) experimental; urgency=medium

  * New upstream version 4.1.0
  * d/control: libzydis4.0 -> libzydis4.1
  * d/control: build-depend on libzycore-dev >= 1.5.0
  * d/.manpages: list files instead of directories
  * d/patches: refresh patches and drop upstreamed ones
  * d/rules: run tests with CMake

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 10 Mar 2024 14:00:34 +0100

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,17 @@
 Source: zydis
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
+Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
 Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13)
-Build-Depends-Arch: dpkg-dev (>= 1.22.5), cmake,
-                    libzycore-dev (>= 1.1.0-3),
+Build-Depends-Arch: cmake,
+                    libzycore-dev (>= 1.5.0),
                     python3 <!nocheck>,
                     ronn
 Build-Depends-Indep: cmake,
                      doxygen <!nodoc>,
                      doxygen-awesome-css <!nodoc>,
                      graphviz <!nodoc>,
-                     libzycore-dev (>= 1.1.0-3),
+                     libzycore-dev (>= 1.5.0),
                      python3 <!nocheck>,
                      ronn
 Standards-Version: 4.6.2
@@ -21,10 +20,7 @@
 Vcs-Browser: https://salsa.debian.org/debian/zydis
 Rules-Requires-Root: no
 
-Package: libzydis4.0t64
-Provides: ${t64:Provides}
-Replaces: libzydis4.0
-Breaks: libzydis4.0 (<< ${source:Version})
+Package: libzydis4.1
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends},
@@ -42,7 +38,7 @@
 Architecture: any
 Multi-Arch: same
 Depends: libzycore-dev (>= 1.0.0-2),
-         libzydis4.0t64 (= ${binary:Version}),
+         libzydis4.1 (= ${binary:Version}),
          ${misc:Depends}
 Description: fast and lightweight x86/x86-64 disassembler library - development
  Zydis is a fast x86/x86-64 disassembler library. It supports all x86 and
@@ -69,7 +65,7 @@
 Section: devel
 Architecture: any
 Multi-Arch: foreign
-Depends: libzydis4.0t64 (= ${binary:Version}),
+Depends: libzydis4.1 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
 Description: fast and lightweight x86/x86-64 disassembler library - tools

=== debian/rules ===
--- 
+++ 
@@ -16,10 +16,8 @@
 		-DZYDIS_BUILD_TOOLS=ON \
 		-DZYAN_SYSTEM_ZYCORE=ON \
 		-DZYDIS_BUILD_MAN=ON \
+		-DZYDIS_BUILD_TESTS=ON \
 		-DCMAKE_BUILD_RPATH_USE_ORIGIN=ON
-
-override_dh_auto_test:
-	cd tests && python3 regression.py test ../build/ZydisInfo
 
 override_dh_installdocs-indep:
 	dh_installdocs --indep --doc-main-package=libzydis-doc
